<template>
  <div>
    <div class="form-row">
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      />
      <div class="form-group col-6">
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          Format
        </label>
        <p>Sélectionner un format dans la liste</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Format FTP"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="isRequired ? classes : ''"
          >
            <Multiselect
              v-model="form.format"
              :options="resourceDataFormats"
              :class="isRequired ? classes : ''"
              track-by="codename"
              label="display_name"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              placeholder="Sélectionner un format"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>
    <div class="form-row">
      <div
        class="form-group col"
        style="margin: 0 1em 0 -5px;"
      >
        <label 
          class="required"
          style="margin-top: 1em;"
        >
          Fichiers
        </label>
        <p>Sélectionner les fichiers dans la liste</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Fichier FTP"
          :rules="`${isRequired ? 'required' : ''}`"
        >
          <div
            class="control"
            :class="isRequired ? classes : ''"
          >
            <Multiselect
              v-model="form.selectedFtpFiles"
              class="ftp-choices"
              :options="ftpChoices"
              :multiple="true"
              track-by="value"
              label="label"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              :close-on-select="false"
              placeholder="Sélectionner les fichiers"
              @select="onSelect"
              @remove="onRemove"
            >
              <span class="checkbox-label" slot="option" slot-scope="scope" @click.self="onSelect(scope.option)">
                {{ scope.option.label }}
                <input class="checkbox" type="checkbox" v-model="scope.option.checked" @focus.prevent/>
              </span>
            </Multiselect>
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>
  </div>
</template>

<script>
import resourcesAPI from '@/api/resourcesAPI.js';

import { mapState, mapActions } from 'vuex';

import Multiselect from 'vue-multiselect';

import { ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'FTPResourceCreator',

  components: {
    ValidationProvider,
    Multiselect
  },

  props: {
    required: {
      type: Boolean,
      default: true
    }
  },

  data() {
    return {
      loading: false,
      isRequired: true,
      form: {
        type: 'ftp',
        format: null,
        selectedFtpFiles: []
      },
      ftpChoices: []
    };
  },

  watch: {
    required(newValue) {
      this.isRequired = newValue;
    },
    form: {
      deep: true,
      handler(newValue) {
        if (newValue.format || newValue.selectedFtpFiles.length) {
          this.setRequired(true);
        } else {
          this.setRequired(false);
        }
      }
    },
    'form.selectedFtpFiles': {
      deep: true,
      handler: async function() {
        this.setResourceFTP();
      }
    }
  },

  computed: {
    ...mapState('resources', [
      'resourceDataFormats',
    ])
  },

  async created() {
    this.isRequired = this.required;
    if (this.resourceDataFormats.length === 0) {
      this.GET_RESOURCE_DATA_FORMATS();
    }
    this.loading = true;
    const ftpChoices = await resourcesAPI.getFTPChoices();
    this.ftpChoices = ftpChoices.map(el => { return { ...el, checked: false } });
    this.ftpChoices.sort((a, b) => {
      return a.label.localeCompare(b.label);
    });
    this.loading = false;
  },

  methods: {
    ...mapActions('resources', [
      'GET_RESOURCE_DATA_FORMATS'
    ]),

    setRequired(e) {
      this.isRequired = e;
      this.$emit('set', {
        required: this.isRequired
      });
    },

    onSelect (option) {
      option.checked = true;
    },
    
    onRemove (option) {
      option.checked = false;
    },

    setResourceFTP() {
      this.$emit('set', {
        form: this.form,
        required: this.isRequired
      });
    }
  }
}
</script>

<style lang="less" scoped>

.checkbox-label {
  display: block;
  margin-right: 2em;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  min-height: 1.1em;
}
.checkbox-label:hover {
  overflow: visible; 
  white-space: normal; 
}

.checkbox {
  position: absolute;
  right: 2vw;
}

</style>
